import { Component, OnInit } from '@angular/core';
import { Validators } from '@angular/forms';
import { FormArray } from '@angular/forms';
import { HttpClient } from '@angular/common/http';
import { FileSaverService } from 'ngx-filesaver';
import { FormControl} from '@angular/forms';
import { FormGroup} from '@angular/forms';


@Component({
  selector: 'app-repository',
  templateUrl: './repository.component.html',
  styleUrls: ['./repository.component.scss']
})

export class RepositoryComponent implements OnInit {

  public fileName: string;
  public importFile: File;

 Form = new FormGroup({
            reponame: new FormControl('', Validators.required),
            repodescription: new FormControl(),
            repourl: new FormControl(),
            repoversion: new FormControl(),
            repolicence: new FormControl(),
            repolanguage: new FormControl(),
            filetofill: new FormControl(),
  });


  constructor(
  private _httpClient: HttpClient,
  private _FileSaverService: FileSaverService,
  ) { }

  ngOnInit() {
  }

  repositorytoyaml(buttonType) {
if (buttonType == 'submit') {
let data: string;
data ='\n\
repository:  \n\
  title: '+ this.Form.value.reponame +' \n\
  description: '+ this.Form.value.repodescription +' \n\
  url: '+ this.Form.value.repourl +' \n\
  version: '+ this.Form.value.repoversion +' \n\
  licence: '+ this.Form.value.repolicence +' \n\
  language: '+ this.Form.value.repolanguage + '\n\
'

    const fileName = `repository.yaml`;
    const fileType = this._FileSaverService.genType(fileName);
    const txtBlob = new Blob([data], { type: fileType });
    this._FileSaverService.save(txtBlob, fileName);
  }

  if (buttonType == 'fill') {
               const files = (event.target as HTMLInputElement).files;
               if (files.length > 0) {
                  this.importFile = files[0];

                  /* lire le fichier ligne à ligne et remplir un array */

                    this.Form.setValue({
                      reponame:    'ça marche !',
                      repodescription: '',
                      repourl: '',
                      repoversion: '',
                      repolicence: '',
                      repolanguage: '',
                      filetofill: ''
                    });
               }
          }

  }


}
